import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

public class FileHandler {
	private String filename;
	private boolean open;
	private String fileContend;

	public FileHandler(String _filename) {
		this.filename = _filename;
	}

	public String getFileContent() {
		return this.fileContend;
	}

	public boolean isOpen() {
		return this.open;
	}

	public boolean readWholeFile() {
		File f = new File(this.filename);
		if (!f.exists()) {
			this.fileContend = ""; //$NON-NLS-1$
			return true;
		}
		this.open = true;
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					this.filename), "UTF-8")); //$NON-NLS-1$
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			return false;
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
			return false;
		}
		StringBuffer contentOfFile = new StringBuffer();
		String line;
		try {
			while ((line = br.readLine()) != null)
				contentOfFile.append(line+"\n");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return false;
		}
		try {
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.fileContend = contentOfFile.toString();
		return true;
	}

	public void setFileContend(String _fileContend) {
		this.fileContend = _fileContend;
	}

	public boolean writeToFile() {
		String[] paths;
		// needed because String.split uses RegExp
		if (File.separator.equals("\\")) //$NON-NLS-1$
			paths = this.filename.split(File.separator + File.separator);
		else
			paths = this.filename.split(File.separator);
		String fname = ""; //$NON-NLS-1$
		for (int c = 0; c < paths.length; c++) {
			if (!fname.equals("")) //$NON-NLS-1$
				fname = fname + File.separator + paths[c];
			else
				fname = paths[c];
			File f = new File(fname);
			if (!f.exists())
				try {
					if (c < (paths.length - 1))
						f.mkdir();
					else
						f.createNewFile();
				} catch (IOException e) {
					System.err.println(fname);
					e.printStackTrace();
				}

		}

		BufferedWriter bw = null;
		try {
			bw = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream(this.filename), "UTF-8")); //$NON-NLS-1$
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
			return false;
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
			return false;
		}
		try {
			bw.write(this.fileContend);
		} catch (IOException e) {
			e.printStackTrace();
		}
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		this.open = false;
		return true;
	}
}
