import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimeZone;

import javax.swing.JOptionPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLEditorKit;

public class MainWindowUI extends javax.swing.JFrame implements SPCalendarCB {
	private static final long serialVersionUID = -8387196805147454104L;

	/** Creates new form Window */
	public MainWindowUI() {
		initComponents();
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	private void initComponents() {
		// own
		String[] fontFamileys = GraphicsEnvironment
				.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
		this.setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		this.setTitle(""); //$NON-NLS-1$
		this.setName("MainFrame"); // NOI18N //$NON-NLS-1$
		this.getContentPane().setMinimumSize(new java.awt.Dimension(600, 300));
		this.textBackUp = new java.util.Stack<TextBackUpData>();
		this.diaryFile = new TBFileHandler();
		this.TBCal = new SPCalendar();
		this.TBCal.setMonthChangeCB(this);
		// end own
		TBLeftPane = new javax.swing.JPanel();
		TBControlsContainer = new javax.swing.JPanel();
		TBLoadButton = new javax.swing.JButton();
		TBLoadButton.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		TBSaveButton = new javax.swing.JButton();
		TBSaveButton.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		TBResetButton = new javax.swing.JButton();
		TBResetButton.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		TBSearchButton = new javax.swing.JButton();
		TBSearchButton.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		TBCreditsPane = new javax.swing.JScrollPane();
		TBCreditsTextPane = new javax.swing.JTextPane();
		TBRightPane = new javax.swing.JPanel();
		TBTextScrollPane = new javax.swing.JScrollPane();
		TBTextPane = new javax.swing.JTextPane();
		TBFormatToolbar = new javax.swing.JToolBar();
		tbFontLabel = new javax.swing.JLabel();
		tbFontCBox = new javax.swing.JComboBox();
		tbFontStyleLabel = new javax.swing.JLabel();
		tbFontStyleCBox = new javax.swing.JComboBox();
		tbSizeLabel = new javax.swing.JLabel();
		tbFontSizeSpinner = new javax.swing.JSpinner();
		// own
		this.TBCreditsTextPane.setEditable(false);
		this.TBCreditsTextPane.setBackground(Color.GRAY);
		this.TBCreditsTextPane.setEditorKit(new HTMLEditorKit());
		this.TBCreditsTextPane.addHyperlinkListener(new HyperlinkListener() {
			@Override
			public void hyperlinkUpdate(HyperlinkEvent event) {
				if (event.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
					try {
						runURL(event.getDescription());
					} catch (Exception ex) {
						JOptionPane.showConfirmDialog(
								null,
								Messages.getString("MainWindowUI.LinkOpenError") + "\n" + event.getDescription()); //$NON-NLS-1$ //$NON-NLS-2$
					}
			}
		});
		this.TBCreditsTextPane.setText(Messages
				.getString("MainWindowUI.Version") //$NON-NLS-1$
				+ String.valueOf(SPTageBuch.version[0])
				+ "." //$NON-NLS-1$
				+ String.valueOf(SPTageBuch.version[1])
				+ Messages.getString("MainWindowUI.Homepage")); //$NON-NLS-1$
		// end own
		setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
		setTitle(Messages.getString("MainWindowUI.Title")); //$NON-NLS-1$
		setName("MainFrame"); // NOI18N //$NON-NLS-1$

		TBLeftPane.setMaximumSize(new java.awt.Dimension(Short.MAX_VALUE, Short.MAX_VALUE));
		TBLeftPane.setMinimumSize(new java.awt.Dimension(232, 500));
		TBLeftPane.setPreferredSize(new java.awt.Dimension(232, 500));

		TBControlsContainer.setMaximumSize(new java.awt.Dimension(232, 52));
		TBControlsContainer.setMinimumSize(new java.awt.Dimension(232, 52));

		TBLoadButton.setText(Messages.getString("MainWindowUI.Load")); //$NON-NLS-1$;
		TBLoadButton.setMaximumSize(new java.awt.Dimension(116, 23));
		TBLoadButton.setMinimumSize(new java.awt.Dimension(116, 23));
		TBLoadButton.setPreferredSize(new java.awt.Dimension(116, 23));
		TBLoadButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				TBLoadButtonMouseClicked();
			}
		});

		this.TBSaveButton.setText(Messages.getString("MainWindowUI.Save")); //$NON-NLS-1$
		TBSaveButton.setMaximumSize(new java.awt.Dimension(116, 23));
		TBSaveButton.setMinimumSize(new java.awt.Dimension(116, 23));
		TBSaveButton.setPreferredSize(new java.awt.Dimension(116, 23));
		TBSaveButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				TBSaveButtonMouseClicked(evt);
			}
		});

		this.TBResetButton.setText(Messages.getString("MainWindowUI.Reset")); //$NON-NLS-1$
		TBResetButton.setAlignmentY(0.0F);
		TBResetButton.setMaximumSize(new java.awt.Dimension(116, 23));
		TBResetButton.setMinimumSize(new java.awt.Dimension(116, 23));
		TBResetButton.setPreferredSize(new java.awt.Dimension(116, 23));
		TBResetButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				TBResetButtonMouseClicked(evt);
			}
		});

		TBSearchButton.setText(Messages.getString("SearchResultWindow.search")); //$NON-NLS-1$
		TBSearchButton.setAlignmentY(0.0F);
		TBSearchButton.setMaximumSize(new java.awt.Dimension(116, 23));
		TBSearchButton.setMinimumSize(new java.awt.Dimension(116, 23));
		TBSearchButton.setPreferredSize(new java.awt.Dimension(116, 23));
		TBSearchButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				TBSearchButtonMouseClicked(evt);
			}
		});

		javax.swing.GroupLayout TBControlsContainerLayout = new javax.swing.GroupLayout(
				TBControlsContainer);
		TBControlsContainer.setLayout(TBControlsContainerLayout);
		TBControlsContainerLayout
				.setHorizontalGroup(TBControlsContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								TBControlsContainerLayout
										.createSequentialGroup()
										.addGroup(
												TBControlsContainerLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.TRAILING,
																false)
														.addComponent(
																TBResetButton,
																javax.swing.GroupLayout.Alignment.LEADING,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE)
														.addComponent(
																TBLoadButton,
																javax.swing.GroupLayout.Alignment.LEADING,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE))
										.addGroup(
												TBControlsContainerLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING,
																false)
														.addComponent(
																TBSearchButton,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE)
														.addComponent(
																TBSaveButton,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE))));
		TBControlsContainerLayout
				.setVerticalGroup(TBControlsContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								TBControlsContainerLayout
										.createSequentialGroup()
										.addGroup(
												TBControlsContainerLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																TBLoadButton,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addComponent(
																TBSaveButton,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										.addGroup(
												TBControlsContainerLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.BASELINE)
														.addComponent(
																TBResetButton,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addComponent(
																TBSearchButton))
										.addContainerGap(
												javax.swing.GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)));

		TBCreditsPane.setViewportView(TBCreditsTextPane);

		javax.swing.GroupLayout TBLeftPaneLayout = new javax.swing.GroupLayout(
				TBLeftPane);
		TBLeftPane.setLayout(TBLeftPaneLayout);
		TBLeftPaneLayout
				.setHorizontalGroup(TBLeftPaneLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								TBLeftPaneLayout
										.createSequentialGroup()
										.addGroup(
												TBLeftPaneLayout
														.createParallelGroup(
																javax.swing.GroupLayout.Alignment.LEADING)
														.addComponent(
																TBCal,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addComponent(
																TBControlsContainer,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addComponent(
																TBCreditsPane,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE))
										));
		TBLeftPaneLayout
				.setVerticalGroup(TBLeftPaneLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								TBLeftPaneLayout
										.createSequentialGroup()
										.addComponent(
												TBCal,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												120,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												TBControlsContainer,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												46,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												TBCreditsPane,
												0,
												134,
												Short.MAX_VALUE)));

		TBTextPane.setFont(new java.awt.Font("Verdana", Font.PLAIN, 12)); // NOI18N //$NON-NLS-1$
		TBTextPane.setCursor(new java.awt.Cursor(java.awt.Cursor.TEXT_CURSOR));
		
		TBTextScrollPane.setViewportView(TBTextPane);

		TBFormatToolbar.setRollover(true);
		TBFormatToolbar.setFloatable(false);

		tbFontLabel.setText(Messages.getString("MainWindowUI.Font")); //$NON-NLS-1$
		TBFormatToolbar.add(tbFontLabel);

		tbFontCBox.setModel(new javax.swing.DefaultComboBoxModel(fontFamileys));
		for (int i = 0; i < fontFamileys.length; i++) {
			if (fontFamileys[i].equalsIgnoreCase("Verdana")) { //$NON-NLS-1$
				tbFontCBox.setSelectedIndex(i);
			}
		}
		tbFontCBox.setAutoscrolls(true);
		tbFontCBox.setMinimumSize(new java.awt.Dimension(50, 18));
		tbFontCBox.setPreferredSize(new java.awt.Dimension(100, 20));
		tbFontCBox.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				tbFontCBoxActionPerformed(evt);
			}

		});
		TBFormatToolbar.add(tbFontCBox);

		tbFontStyleLabel.setText(Messages.getString("MainWindowUI.style")); //$NON-NLS-1$
		TBFormatToolbar.add(tbFontStyleLabel);

		tbFontStyleCBox
				.setModel(new javax.swing.DefaultComboBoxModel(
						new String[] {
								Messages.getString("MainWindowUI.plain"), Messages.getString("MainWindowUI.bold"), Messages.getString("MainWindowUI.italic") })); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		tbFontStyleCBox.addActionListener(new java.awt.event.ActionListener() {
			@Override
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				tbFontStyleCBoxActionPerformed(evt);
			}
		});
		TBFormatToolbar.add(tbFontStyleCBox);

		tbSizeLabel.setText(Messages.getString("MainWindowUI.Size")); //$NON-NLS-1$
		TBFormatToolbar.add(tbSizeLabel);

		tbFontSizeSpinner.setModel(new javax.swing.SpinnerNumberModel(Integer
				.valueOf(12), null, null, Integer.valueOf(1)));
		tbFontSizeSpinner.setToolTipText(Messages
				.getString("MainWindowUI.chnageFontsSize")); //$NON-NLS-1$
		tbFontSizeSpinner.setMinimumSize(new java.awt.Dimension(30, 20));
		tbFontSizeSpinner.setPreferredSize(new java.awt.Dimension(40, 20));
		tbFontSizeSpinner.setMaximumSize(new java.awt.Dimension(40, 20));
		tbFontSizeSpinner
				.addChangeListener(new javax.swing.event.ChangeListener() {
					@Override
					public void stateChanged(javax.swing.event.ChangeEvent evt) {
						tbFontSizeSpinnerStateChanged(evt);
					}
				});
		TBFormatToolbar.add(tbFontSizeSpinner);

		javax.swing.GroupLayout TBRightPaneLayout = new javax.swing.GroupLayout(
				TBRightPane);
		TBRightPane.setLayout(TBRightPaneLayout);
		TBRightPaneLayout.setHorizontalGroup(TBRightPaneLayout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addComponent(TBTextScrollPane,
						javax.swing.GroupLayout.DEFAULT_SIZE, 368,
						Short.MAX_VALUE)
				.addComponent(TBFormatToolbar,
						javax.swing.GroupLayout.DEFAULT_SIZE, 368,
						Short.MAX_VALUE));
		TBRightPaneLayout.setVerticalGroup(TBRightPaneLayout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						TBRightPaneLayout
								.createSequentialGroup()
								.addComponent(TBFormatToolbar,
										javax.swing.GroupLayout.PREFERRED_SIZE,
										25,
										javax.swing.GroupLayout.PREFERRED_SIZE)
								.addComponent(TBTextScrollPane,
										javax.swing.GroupLayout.DEFAULT_SIZE,
										275, Short.MAX_VALUE)));

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				getContentPane());
		getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout.createParallelGroup(
				javax.swing.GroupLayout.Alignment.LEADING).addGroup(
				layout.createSequentialGroup()
						.addComponent(TBLeftPane,
								javax.swing.GroupLayout.PREFERRED_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.PREFERRED_SIZE)
						.addComponent(TBRightPane,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								javax.swing.GroupLayout.DEFAULT_SIZE,
								Short.MAX_VALUE)));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addComponent(TBRightPane,
						javax.swing.GroupLayout.DEFAULT_SIZE,
						javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
				.addComponent(TBLeftPane,
						javax.swing.GroupLayout.PREFERRED_SIZE, 300,
						Short.MAX_VALUE));
		pack();
	}// </editor-fold>

	void TBLoadButtonMouseClicked() {
		Date date;
		date = this.diaryFile.getFileDate();
		if (date != null)
			this.textBackUp.push(new TextBackUpData(this.TBTextPane.getText(),
					date));
		date = this.TBCal.getDate();
		this.diaryFile.setFilename(date);
		this.diaryFile.readWholeFile();
		this.TBTextPane.setText(this.diaryFile.getFileContend());
		this.writeInfo();
	}

	private void TBSaveButtonMouseClicked(java.awt.event.MouseEvent evt) {
		Date date = this.TBCal.getDate();
		this.diaryFile.setFilename(date);
		this.diaryFile.setFileContend(this.TBTextPane.getText());
		this.diaryFile.writeToFile();
		this.textBackUp
				.push(new TextBackUpData(this.TBTextPane.getText(), date));
		this.MonthChanged();
		this.writeInfo();
	}

	private void TBResetButtonMouseClicked(java.awt.event.MouseEvent evt) {
		if (!this.textBackUp.empty()) {
			TextBackUpData tbd = this.textBackUp.pop();
			this.TBTextPane.setText(tbd.text);
			this.TBCal.setDate(tbd.date);
		}
	}

	private void TBSearchButtonMouseClicked(java.awt.event.MouseEvent evt) {
		final MainWindowUI mw = this;
		(new Thread() {
			@Override
			public void run() {
				SearchResultWindow srw = new SearchResultWindow(mw,
						mw.getLocation());
				srw.setVisible(true);
			}
		}).start();
	}

	private void tbFontCBoxActionPerformed(ActionEvent evt) {
		int fSizeInt, fStyleInt;
		String fName = (String) this.tbFontCBox.getSelectedItem();
		if (fName == null || fName == "") //$NON-NLS-1$
			fName = this.TBTextPane.getFont().getFamily();

		fSizeInt = this.TBTextPane.getFont().getSize();
		fStyleInt = this.TBTextPane.getFont().getStyle();
		this.TBTextPane.setFont(new Font(fName, fStyleInt, fSizeInt));
	}

	private void tbFontStyleCBoxActionPerformed(ActionEvent evt) {
		int fSizeInt = this.TBTextPane.getFont().getSize();
		int fStyleInt = this.TBTextPane.getFont().getStyle();
		String fName = this.TBTextPane.getFont().getFamily();
		String fStyle = (String) this.tbFontStyleCBox.getSelectedItem();
		if (fStyle.equals(Messages.getString("MainWindowUI.plain"))) { //$NON-NLS-1$
			fStyleInt = Font.PLAIN;
		} else {
			if (fStyle.equals(Messages.getString("MainWindowUI.bold"))) { //$NON-NLS-1$
				fStyleInt = Font.BOLD;
			} else {
				if (fStyle.equals(Messages.getString("MainWindowUI.italic"))) { //$NON-NLS-1$
					fStyleInt = Font.ITALIC;
				}
			}
		}

		this.TBTextPane.setFont(new Font(fName, fStyleInt, fSizeInt));

	}

	private void tbFontSizeSpinnerStateChanged(ChangeEvent evt) {
		int fSizeInt = (Integer) this.tbFontSizeSpinner.getValue(), fStyleInt = this.TBTextPane
				.getFont().getStyle();
		String fName = this.TBTextPane.getFont().getFamily();
		this.TBTextPane.setFont(new Font(fName, fStyleInt, fSizeInt));

	}

	// own
	public SPCalendar getTBCal() {
		return this.TBCal;
	}

	@Override
	public void MonthChanged() {
		(new Thread() {
			@Override
			public void run() {
				MainWindowUI.this.TBCal.clearAllMarks();
				String[] fnames;
				Date currDate = MainWindowUI.this.TBCal.getDate();
				SimpleDateFormat df = new SimpleDateFormat(
						"."		+ File.separator + "yyyy" + File.separator + "MM" + File.separator); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				df.setTimeZone(TimeZone.getDefault());
				String path = df.format(currDate);
				File f = new File(path);
				if (f.exists() && f.isDirectory())
					fnames = f.list(new TBFileFilter());
				else
					fnames = null;
				if (fnames != null)
					for (String n : fnames)
						// TODO: Prevent Crashes on false names
						MainWindowUI.this.TBCal.setMarked(Integer.parseInt(n
								.substring(0, n.length() - 3)));
			}
		}).start();

	}

	public static boolean isWindows() {
		String os = System.getProperty("os.name"); //$NON-NLS-1$
		if ((os != null) && os.startsWith(WIN_NAME))
			return true;
		return false;
	}

	public static void runURL(String url) throws InterruptedException,
			IOException {
		boolean windows = isWindows();
		String cmd = null;
		if (windows) {
			cmd = WIN_PATH + " " + WIN_FLAG + " " + url; //$NON-NLS-1$ //$NON-NLS-2$
			Runtime.getRuntime().exec(cmd);
		} else {
			cmd = UNIX_PATH + " " + UNIX_FLAG + "(" + url + ")"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			Process p = Runtime.getRuntime().exec(cmd);
			int exitCode = p.waitFor();
			if (exitCode != 0) {
				cmd = UNIX_PATH + " " + url; //$NON-NLS-1$
				p = Runtime.getRuntime().exec(cmd);
			}
		}
	}

	private void writeInfo() {
		if (!this.diaryFile.isPlain() && this.diaryFile.isOldformat())
			this.TBCreditsTextPane.setText("<p>" //$NON-NLS-1$
					+ Messages.getString("MainWindowUI.Fileformat") //$NON-NLS-1$
					+ this.diaryFile.getFormatVersion()
					+ "<br>" //$NON-NLS-1$
					+ Messages.getString("MainWindowUI.Lastchange") //$NON-NLS-1$
					+ Messages
							.getString("MainWindowUI.NotAvailableInThisFormat") //$NON-NLS-1$
					+ "</p><p>" //$NON-NLS-1$
					+ Messages.getString("MainWindowUI.OldFormatWarning") //$NON-NLS-1$
					+ String.valueOf(SPTageBuch.version[0])
					+ "." //$NON-NLS-1$
					+ String.valueOf(SPTageBuch.version[1])
					+ Messages.getString("MainWindowUI.Homepage") + "</p>"); //$NON-NLS-1$ //$NON-NLS-2$
		else
			if (this.diaryFile.isPlain())
				this.TBCreditsTextPane
						.setText("<p>" //$NON-NLS-1$
								+ Messages.getString("MainWindowUI.Fileformat") //$NON-NLS-1$
								+ Messages
										.getString("MainWindowUI.NormalTextNotFormat") //$NON-NLS-1$
								+ "<br>" //$NON-NLS-1$
								+ Messages.getString("MainWindowUI.Lastchange") //$NON-NLS-1$
								+ Messages
										.getString("MainWindowUI.NotAvailableInThisFormat") //$NON-NLS-1$
								+ "</p><p>" //$NON-NLS-1$
								+ Messages
										.getString("MainWindowUI.OldFormatWarning") //$NON-NLS-1$
								+ String.valueOf(SPTageBuch.version[0])
								+ "." //$NON-NLS-1$
								+ String.valueOf(SPTageBuch.version[1])
								+ Messages.getString("MainWindowUI.Homepage") + "</p>"); //$NON-NLS-1$ //$NON-NLS-2$
			else
				this.TBCreditsTextPane.setText("<p>" //$NON-NLS-1$
						+ Messages.getString("MainWindowUI.Fileformat") //$NON-NLS-1$
						+ this.diaryFile.getFormatVersion()
						+ "<br>" //$NON-NLS-1$
						+ Messages.getString("MainWindowUI.Lastchange") //$NON-NLS-1$
						+ (new SimpleDateFormat("yyyy-MM-dd")) //$NON-NLS-1$
								.format(this.diaryFile.getLastedit())
						+ "</p><p>" //$NON-NLS-1$
						+ Messages.getString("MainWindowUI.Version") //$NON-NLS-1$
						+ String.valueOf(SPTageBuch.version[0])
						+ "." //$NON-NLS-1$
						+ String.valueOf(SPTageBuch.version[1])
						+ Messages.getString("MainWindowUI.Homepage") + "</p>"); //$NON-NLS-1$ //$NON-NLS-2$
	}

	// end own

	// Variables declaration - do not modify
	private javax.swing.JPanel TBControlsContainer;
	private javax.swing.JScrollPane TBCreditsPane;
	private javax.swing.JTextPane TBCreditsTextPane;
	private javax.swing.JToolBar TBFormatToolbar;
	private javax.swing.JPanel TBLeftPane;
	private javax.swing.JButton TBResetButton;
	private javax.swing.JPanel TBRightPane;
	private javax.swing.JButton TBSaveButton;
	private javax.swing.JButton TBSearchButton;
	private javax.swing.JTextPane TBTextPane;
	private javax.swing.JScrollPane TBTextScrollPane;
	private javax.swing.JButton TBLoadButton;
	private javax.swing.JComboBox tbFontCBox;
	private javax.swing.JLabel tbFontLabel;
	private javax.swing.JSpinner tbFontSizeSpinner;
	private javax.swing.JComboBox tbFontStyleCBox;
	private javax.swing.JLabel tbFontStyleLabel;
	private javax.swing.JLabel tbSizeLabel;
	// End of variables declaration
	// own
	private static String WIN_NAME = "Windows"; //$NON-NLS-1$
	private static String WIN_PATH = "rundll32"; //$NON-NLS-1$
	private static String WIN_FLAG = "url.dll,FileProtocolHandler"; //$NON-NLS-1$
	private static String UNIX_PATH = "netscape"; //$NON-NLS-1$
	private static String UNIX_FLAG = "-remote openURL"; //$NON-NLS-1$
	private SPCalendar TBCal;
	private TBFileHandler diaryFile;
	private java.util.Stack<TextBackUpData> textBackUp;
	// end own
}

class TextBackUpData {
	public String text;

	public Date date;

	public TextBackUpData(String text, Date date) {
		this.text = text;
		this.date = date;
	}
}