/*  
 JSPDiary is an easy and clear to use diary program.
 Copyright (C) 2010  Constantin Wenger aka SpeedProg <constantin.wenger@googlemail.com>

 This file is part of JSPDiary.

 JSPDiary is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JSPDiary is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JPidGinStatistik.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {

	public static String getString(String key) {
		ResourceBundle RESOURCE_BUNDLE;
		// load the default language
		try {
			RESOURCE_BUNDLE = ResourceBundle
					.getBundle("languagepacks.jspdiary"); //$NON-NLS-1$
		} catch (MissingResourceException e) {
			// if not found try loading the en language!
			try {
				RESOURCE_BUNDLE = ResourceBundle.getBundle(
						"languagepacks.jspdiary", new Locale("en", "GB")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			} catch (MissingResourceException e2) {
				// if en language not found return the key!
				return " !" + key + "! "; //$NON-NLS-1$ //$NON-NLS-2$
			}
			// if default not found but en found try getting the keys value
			try {
				// if found return the string
				return RESOURCE_BUNDLE.getString(key);
			} catch (MissingResourceException e2) {
				// if the key is not found return the key
				return " !" + key + "! "; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		// if loading the defoult language succeeded
		try {
			// if found return the string
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			// if not found trie loading the en language
			try {
				RESOURCE_BUNDLE = ResourceBundle.getBundle(
						"languagepacks.jspdiary", new Locale("en", "GB")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			} catch (MissingResourceException e2) {
				// if en language not found return the key!
				return " !" + key + "! "; //$NON-NLS-1$ //$NON-NLS-2$
			}
			// if default not found an en found try getting the keys value
			try {
				// if found return the string
				return RESOURCE_BUNDLE.getString(key);
			} catch (MissingResourceException e2) {
				// if the key is not found return the key
				return " !" + key + "! "; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
	}
}
