/*  
    JSPDiary is an easy and clear to use diary program.
    Copyright (C) 2010  Constantin Wenger aka SpeedProg <constantin.wenger@googlemail.com>

    This file is part of JSPDiary.

    JSPDiary is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    JSPDiary is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with JPidGinStatistik.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.Color;
import java.awt.Font;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.Locale;

import javax.swing.JPanel;

public class SPCalendar extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8934255624605654060L;
	/**
	 * 
	 */
	private GregorianCalendar calDate;
	private int[][] calLabelMap = { { -1, -1, -1, -1, -1, -1, -1 },
			{ -1, -1, -1, -1, -1, -1, -1 }, { -1, -1, -1, -1, -1, -1, -1 },
			{ -1, -1, -1, -1, -1, -1, -1 }, { -1, -1, -1, -1, -1, -1, -1 },
			{ -1, -1, -1, -1, -1, -1, -1 } };
	private LinkedList<int[]> calLabelList;
	private boolean[] calMarkedArray = { false, false, false, false, false,
			false, false, false, false, false, false, false, false, false,
			false, false, false, false, false, false, false, false, false,
			false, false, false, false, false, false, false, false };
	private javax.swing.JLabel[][] calDay;
	private int calLastDayChoosen[];
	private javax.swing.JPanel calDayContainer;
	private javax.swing.JPanel calDayNameContainer;
	private javax.swing.JPanel calDaysRowContainer0;
	private javax.swing.JPanel calDaysRowContainer1;
	private javax.swing.JPanel calDaysRowContainer2;
	private javax.swing.JPanel calDaysRowContainer3;
	private javax.swing.JPanel calDaysRowContainer4;
	private javax.swing.JPanel calDaysRowContainer5;
	private javax.swing.JButton calDecrease;
	private javax.swing.JLabel calDieLabel;
	private javax.swing.JLabel calDoLabel;
	private javax.swing.JLabel calFreLabel;
	private javax.swing.JButton calIncrease;
	private javax.swing.JLabel calMitLabel;
	private javax.swing.JLabel calMonLabel;
	private javax.swing.JLabel calSamLabel;
	private javax.swing.JLabel calSonLabel;
	private javax.swing.JPanel calMonthContainer;
	private javax.swing.JLabel calMonthLabel;
	private SPCalendarCB calMonthChangedCB;

	public SPCalendar() {
		this.calLastDayChoosen = new int[2];
		this.calLastDayChoosen[0] = -1;
		this.calLastDayChoosen[1] = -1;
		this.calDate = new GregorianCalendar();
		this.calLabelList = new LinkedList<int[]>();
		this.calMonthContainer = new javax.swing.JPanel();
		this.calMonthLabel = new javax.swing.JLabel();
		this.calDecrease = new javax.swing.JButton();
		this.calDecrease.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		this.calIncrease = new javax.swing.JButton();
		this.calIncrease.setFont(new Font("Arial", Font.BOLD, 12)); //$NON-NLS-1$
		this.calDayNameContainer = new javax.swing.JPanel();
		this.calMitLabel = new javax.swing.JLabel();
		this.calDoLabel = new javax.swing.JLabel();
		this.calFreLabel = new javax.swing.JLabel();
		this.calSamLabel = new javax.swing.JLabel();
		this.calSonLabel = new javax.swing.JLabel();
		this.calDieLabel = new javax.swing.JLabel();
		this.calMonLabel = new javax.swing.JLabel();
		this.calDayContainer = new javax.swing.JPanel();
		this.calDaysRowContainer0 = new javax.swing.JPanel();
		this.calDay = new javax.swing.JLabel[6][7];
		this.calDay[0][0] = new javax.swing.JLabel();
		this.calDay[0][1] = new javax.swing.JLabel();
		this.calDay[0][2] = new javax.swing.JLabel();
		this.calDay[0][3] = new javax.swing.JLabel();
		this.calDay[0][4] = new javax.swing.JLabel();
		this.calDay[0][5] = new javax.swing.JLabel();
		this.calDay[0][6] = new javax.swing.JLabel();
		this.calDaysRowContainer1 = new javax.swing.JPanel();
		this.calDay[1][0] = new javax.swing.JLabel();
		this.calDay[1][1] = new javax.swing.JLabel();
		this.calDay[1][2] = new javax.swing.JLabel();
		this.calDay[1][3] = new javax.swing.JLabel();
		this.calDay[1][4] = new javax.swing.JLabel();
		this.calDay[1][5] = new javax.swing.JLabel();
		this.calDay[1][6] = new javax.swing.JLabel();
		this.calDaysRowContainer2 = new javax.swing.JPanel();
		this.calDay[2][0] = new javax.swing.JLabel();
		this.calDay[2][1] = new javax.swing.JLabel();
		this.calDay[2][2] = new javax.swing.JLabel();
		this.calDay[2][3] = new javax.swing.JLabel();
		this.calDay[2][4] = new javax.swing.JLabel();
		this.calDay[2][5] = new javax.swing.JLabel();
		this.calDay[2][6] = new javax.swing.JLabel();
		this.calDaysRowContainer3 = new javax.swing.JPanel();
		this.calDay[3][0] = new javax.swing.JLabel();
		this.calDay[3][1] = new javax.swing.JLabel();
		this.calDay[3][2] = new javax.swing.JLabel();
		this.calDay[3][3] = new javax.swing.JLabel();
		this.calDay[3][4] = new javax.swing.JLabel();
		this.calDay[3][5] = new javax.swing.JLabel();
		this.calDay[3][6] = new javax.swing.JLabel();
		this.calDaysRowContainer4 = new javax.swing.JPanel();
		this.calDay[4][0] = new javax.swing.JLabel();
		this.calDay[4][1] = new javax.swing.JLabel();
		this.calDay[4][2] = new javax.swing.JLabel();
		this.calDay[4][3] = new javax.swing.JLabel();
		this.calDay[4][4] = new javax.swing.JLabel();
		this.calDay[4][5] = new javax.swing.JLabel();
		this.calDay[4][6] = new javax.swing.JLabel();
		this.calDaysRowContainer5 = new javax.swing.JPanel();
		this.calDay[5][0] = new javax.swing.JLabel();
		this.calDay[5][1] = new javax.swing.JLabel();
		this.calDay[5][2] = new javax.swing.JLabel();
		this.calDay[5][3] = new javax.swing.JLabel();
		this.calDay[5][4] = new javax.swing.JLabel();
		this.calDay[5][5] = new javax.swing.JLabel();
		this.calDay[5][6] = new javax.swing.JLabel();
		this.setMaximumSize(new java.awt.Dimension(232, 120));
		this.setMinimumSize(new java.awt.Dimension(232, 120));
		this.setPreferredSize(new java.awt.Dimension(232, 120));

		this.calMonthContainer.setMaximumSize(new java.awt.Dimension(212, 25));
		this.calMonthContainer.setMinimumSize(new java.awt.Dimension(212, 25));

		this.calMonthLabel
				.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
		this.calMonthLabel.setText(this.calDate.getDisplayName(Calendar.MONTH,
				Calendar.LONG, Locale.getDefault())
				+ " " + String.valueOf(this.calDate.get(Calendar.YEAR))); //$NON-NLS-1$

		this.calDecrease.setText("<"); //$NON-NLS-1$
		this.calDecrease.setPreferredSize(new java.awt.Dimension(41, 25));
		this.calDecrease.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDecreaseMouseClicked(evt);
			}
		});

		this.calIncrease.setText(">"); //$NON-NLS-1$
		this.calIncrease.setMaximumSize(new java.awt.Dimension(41, 25));
		this.calIncrease.setMinimumSize(new java.awt.Dimension(41, 25));
		this.calIncrease.setPreferredSize(new java.awt.Dimension(41, 25));
		this.calIncrease.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalIncreaseMouseClicked(evt);
			}
		});

		javax.swing.GroupLayout calMonthContainerLayout = new javax.swing.GroupLayout(
				this.calMonthContainer);
		this.calMonthContainer.setLayout(calMonthContainerLayout);
		calMonthContainerLayout
				.setHorizontalGroup(calMonthContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								calMonthContainerLayout
										.createSequentialGroup()
										.addComponent(
												this.calDecrease,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												41,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calMonthLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												122,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calIncrease,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												41,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addContainerGap(20, Short.MAX_VALUE)));
		calMonthContainerLayout.setVerticalGroup(calMonthContainerLayout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						calMonthContainerLayout.createParallelGroup(
								javax.swing.GroupLayout.Alignment.BASELINE)
								.addComponent(this.calMonthLabel).addComponent(
										this.calIncrease,
										javax.swing.GroupLayout.DEFAULT_SIZE,
										25, Short.MAX_VALUE)).addComponent(
						this.calDecrease,
						javax.swing.GroupLayout.PREFERRED_SIZE, 25,
						javax.swing.GroupLayout.PREFERRED_SIZE));

		this.calDayNameContainer
				.setMaximumSize(new java.awt.Dimension(212, 20));
		this.calDayNameContainer
				.setMinimumSize(new java.awt.Dimension(212, 20));

		GregorianCalendar calTmpCal = new GregorianCalendar(2010,
				Calendar.JUNE, 7);
		this.calMonLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calMonLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calMonLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calMonLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal.set(Calendar.DAY_OF_MONTH, 1);
		this.calDieLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calDieLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calDieLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calDieLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal.set(Calendar.DAY_OF_MONTH, 2);
		this.calMitLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calMitLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calMitLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calMitLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal.set(Calendar.DAY_OF_MONTH, 3);
		this.calDoLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calDoLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calDoLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calDoLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal.set(Calendar.DAY_OF_MONTH, 4);
		this.calFreLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calFreLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calFreLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calFreLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal.set(Calendar.DAY_OF_MONTH, 5);
		this.calSamLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calSamLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calSamLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calSamLabel.setPreferredSize(new java.awt.Dimension(25, 20));
		this.calSamLabel.setRequestFocusEnabled(false);

		calTmpCal.set(Calendar.DAY_OF_MONTH, 6);
		this.calSonLabel.setText(calTmpCal.getDisplayName(Calendar.DAY_OF_WEEK,
				Calendar.SHORT, Locale.getDefault()));
		this.calSonLabel.setMaximumSize(new java.awt.Dimension(25, 20));
		this.calSonLabel.setMinimumSize(new java.awt.Dimension(25, 20));
		this.calSonLabel.setPreferredSize(new java.awt.Dimension(25, 20));

		calTmpCal = null;

		javax.swing.GroupLayout calDayNameContainerLayout = new javax.swing.GroupLayout(
				this.calDayNameContainer);
		this.calDayNameContainer.setLayout(calDayNameContainerLayout);
		calDayNameContainerLayout
				.setHorizontalGroup(calDayNameContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								calDayNameContainerLayout
										.createSequentialGroup()
										.addComponent(
												this.calMonLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calDieLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calMitLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calDoLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calFreLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED)
										.addComponent(
												this.calSamLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addPreferredGap(
												javax.swing.LayoutStyle.ComponentPlacement.RELATED,
												7, Short.MAX_VALUE)
										.addComponent(
												this.calSonLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												25,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addContainerGap()));
		calDayNameContainerLayout
				.setVerticalGroup(calDayNameContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								calDayNameContainerLayout
										.createParallelGroup(
												javax.swing.GroupLayout.Alignment.BASELINE)
										.addComponent(
												this.calMonLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calMitLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												20,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calDoLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calFreLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												20,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calSamLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												20,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calSonLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												20,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addComponent(
												this.calDieLabel,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												javax.swing.GroupLayout.PREFERRED_SIZE)));

		this.calDayContainer.setMaximumSize(new java.awt.Dimension(212, 100));
		this.calDayContainer.setLayout(new java.awt.GridLayout(6, 1));

		this.calDaysRowContainer0
				.setMaximumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer0
				.setMinimumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer0.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer0.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[0][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][0]);

		this.calDay[0][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][1]);

		this.calDay[0][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][2]);

		this.calDay[0][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][3]);

		this.calDay[0][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][4]);

		this.calDay[0][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][5]);

		this.calDay[0][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[0][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[0][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay0x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer0.add(this.calDay[0][6]);

		this.calDayContainer.add(this.calDaysRowContainer0);

		this.calDaysRowContainer1
				.setMaximumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer1
				.setMinimumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer1.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer1.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[1][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][0]);

		this.calDay[1][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][1]);

		this.calDay[1][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][2]);

		this.calDay[1][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][3]);

		this.calDay[1][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][4]);

		this.calDay[1][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][5]);

		this.calDay[1][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[1][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[1][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay1x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer1.add(this.calDay[1][6]);

		this.calDayContainer.add(this.calDaysRowContainer1);

		this.calDaysRowContainer2
				.setMaximumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer2
				.setMinimumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer2.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer2.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[2][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][0]);

		this.calDay[2][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][1]);

		this.calDay[2][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][2]);

		this.calDay[2][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][3]);

		this.calDay[2][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][4]);

		this.calDay[2][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][5]);

		this.calDay[2][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[2][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[2][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay2x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer2.add(this.calDay[2][6]);

		this.calDayContainer.add(this.calDaysRowContainer2);

		this.calDaysRowContainer3
				.setMaximumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer3
				.setMinimumSize(new java.awt.Dimension(212, 15));
		this.calDaysRowContainer3.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer3.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[3][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][0]);

		this.calDay[3][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][1]);

		this.calDay[3][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][2]);

		this.calDay[3][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][3]);

		this.calDay[3][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][4]);

		this.calDay[3][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][5]);

		this.calDay[3][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[3][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[3][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay3x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer3.add(this.calDay[3][6]);

		this.calDayContainer.add(this.calDaysRowContainer3);

		this.calDaysRowContainer4.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer4.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[4][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][0]);

		this.calDay[4][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][1]);

		this.calDay[4][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][2]);

		this.calDay[4][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][3]);

		this.calDay[4][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][4]);

		this.calDay[4][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][5]);

		this.calDay[4][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[4][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[4][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay4x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer4.add(this.calDay[4][6]);

		this.calDayContainer.add(this.calDaysRowContainer4);

		this.calDaysRowContainer5.setPreferredSize(new java.awt.Dimension(212,
				15));
		this.calDaysRowContainer5.setLayout(new java.awt.GridLayout(1, 7));

		this.calDay[5][0].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][0].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][0].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][0].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x0MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][0]);

		this.calDay[5][1].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][1].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][1].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][1].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x1MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][1]);

		this.calDay[5][2].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][2].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][2].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][2].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x2MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][2]);

		this.calDay[5][3].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][3].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][3].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][3].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x3MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][3]);

		this.calDay[5][4].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][4].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][4].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][4].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x4MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][4]);

		this.calDay[5][5].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][5].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][5].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][5].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x5MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][5]);

		this.calDay[5][6].setMaximumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][6].setMinimumSize(new java.awt.Dimension(25, 15));
		this.calDay[5][6].setPreferredSize(new java.awt.Dimension(25, 15));
		this.calDay[5][6].addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SPCalendar.this.CalDay5x6MouseClicked(evt);
			}
		});
		this.calDaysRowContainer5.add(this.calDay[5][6]);

		this.calDayContainer.add(this.calDaysRowContainer5);

		javax.swing.GroupLayout CalContainerLayout = new javax.swing.GroupLayout(
				this);
		this.setLayout(CalContainerLayout);
		CalContainerLayout
				.setHorizontalGroup(CalContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								CalContainerLayout
										.createSequentialGroup()
										.addComponent(
												this.calDayNameContainer,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												Short.MAX_VALUE)
										.addContainerGap())
						.addGroup(
								CalContainerLayout
										.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
										.addGroup(
												CalContainerLayout
														.createSequentialGroup()
														.addGap(0, 0, 0)
														.addComponent(
																this.calMonthContainer,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE)))
						.addGroup(
								CalContainerLayout
										.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
										.addGroup(
												CalContainerLayout
														.createSequentialGroup()
														.addGap(0, 0, 0)
														.addComponent(
																this.calDayContainer,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																212,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addGap(0, 0, 0))));
		CalContainerLayout
				.setVerticalGroup(CalContainerLayout
						.createParallelGroup(
								javax.swing.GroupLayout.Alignment.LEADING)
						.addGroup(
								CalContainerLayout
										.createSequentialGroup()
										.addGap(25, 25, 25)
										.addComponent(
												this.calDayNameContainer,
												javax.swing.GroupLayout.PREFERRED_SIZE,
												javax.swing.GroupLayout.DEFAULT_SIZE,
												javax.swing.GroupLayout.PREFERRED_SIZE)
										.addContainerGap(75, Short.MAX_VALUE))
						.addGroup(
								CalContainerLayout
										.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
										.addGroup(
												CalContainerLayout
														.createSequentialGroup()
														.addGap(0, 0, 0)
														.addComponent(
																this.calMonthContainer,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																javax.swing.GroupLayout.DEFAULT_SIZE,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addContainerGap(95,
																Short.MAX_VALUE)))
						.addGroup(
								CalContainerLayout
										.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
										.addGroup(
												CalContainerLayout
														.createSequentialGroup()
														.addGap(45, 45, 45)
														.addComponent(
																this.calDayContainer,
																javax.swing.GroupLayout.PREFERRED_SIZE,
																75,
																javax.swing.GroupLayout.PREFERRED_SIZE)
														.addContainerGap(
																javax.swing.GroupLayout.DEFAULT_SIZE,
																Short.MAX_VALUE))));
		this.update();
	}

	public void clearAllMarks() {
		for (int c = 0; c < 31; c++)
			this.calMarkedArray[c] = false;
		this.update();
	}

	public Date getDate() {
		return this.calDate.getTime();

	}

	@SuppressWarnings("deprecation")
	public void setDate(Date date) {
		boolean mChanged = false;
		if ((this.calDate.get(Calendar.YEAR) - 1900 != date.getYear())
				|| (this.calDate.get(Calendar.MONTH) != date.getMonth()))
			mChanged = true;
		this.calDate.set(Calendar.YEAR, date.getYear() + 1900);
		this.calDate.set(Calendar.MONTH, date.getMonth());
		this.calDate.set(Calendar.DATE, date.getDate());
		if (mChanged)
			this.calMonthChangedCB.MonthChanged();
		this.update();
	}

	public void setMarked(int daynum) {
		if ((daynum > 0) && (daynum <= 31))
			this.calMarkedArray[daynum - 1] = true;
		this.update();
	}

	public void setMonthChangeCB(SPCalendarCB r) {
		this.calMonthChangedCB = r;
		this.calMonthChangedCB.MonthChanged();
	}

	public void unsetMarked(int daynum) {
		if ((daynum > 0) && (daynum <= 31))
			this.calMarkedArray[daynum - 1] = false;
		this.update();
	}

	private void CalDay0x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 0));
	}

	private void CalDay0x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 1));
	}

	private void CalDay0x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 2));
	}

	private void CalDay0x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 3));
	}

	private void CalDay0x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 4));
	}

	private void CalDay0x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 5));
	}

	private void CalDay0x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(0, 6));
	}

	private void CalDay1x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 0));
	}

	private void CalDay1x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 1));
	}

	private void CalDay1x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 2));
	}

	private void CalDay1x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 3));
	}

	private void CalDay1x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 4));
	}

	private void CalDay1x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 5));
	}

	private void CalDay1x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(1, 6));
	}

	private void CalDay2x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 0));
	}

	private void CalDay2x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 1));
	}

	private void CalDay2x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 2));
	}

	private void CalDay2x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 3));
	}

	private void CalDay2x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 4));
	}

	private void CalDay2x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 5));
	}

	private void CalDay2x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(2, 6));
	}

	private void CalDay3x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 0));
	}

	private void CalDay3x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 1));
	}

	private void CalDay3x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 2));
	}

	private void CalDay3x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 3));
	}

	private void CalDay3x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 4));
	}

	private void CalDay3x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 5));
	}

	private void CalDay3x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(3, 6));
	}

	private void CalDay4x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 0));
	}

	private void CalDay4x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 1));
	}

	private void CalDay4x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 2));
	}

	private void CalDay4x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 3));
	}

	private void CalDay4x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 4));
	}

	private void CalDay4x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 5));
	}

	private void CalDay4x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(4, 6));
	}

	private void CalDay5x0MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 0));
	}

	private void CalDay5x1MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 1));
	}

	private void CalDay5x2MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 2));
	}

	private void CalDay5x3MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 3));
	}

	private void CalDay5x4MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 4));
	}

	private void CalDay5x5MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 5));
	}

	private void CalDay5x6MouseClicked(java.awt.event.MouseEvent evt) {
		this.setDay(this.getDayToLabel(5, 6));
	}

	private void CalDecreaseMouseClicked(java.awt.event.MouseEvent evt) {
		this.calDate.add(Calendar.MONTH, -1);
		this.update();
		this.calMonthChangedCB.MonthChanged();
	}

	private void CalIncreaseMouseClicked(java.awt.event.MouseEvent evt) {
		this.calDate.add(Calendar.MONTH, 1);
		this.update();
		(this.calMonthChangedCB).MonthChanged();
	}

	private boolean DateIsLeapYear(int iYear) {
		if (((iYear % 4) == 0) && (iYear % 100 != 0))
			return true;
		if ((iYear % 400) == 0)
			return true;
		return false;
	}

	private int DaysInMonth(int iYear, int iMonth) {
		int[] Days = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
		if ((iMonth > 0) && (iMonth < 13)) {
			if (iMonth == 2) {
				if (this.DateIsLeapYear(iYear))
					return 29;
				return 28;
			}
			return Days[iMonth - 1];
		}
		return -1;
	}

	private int getDayToLabel(int y, int x) {
		return this.calLabelMap[y][x];
	}

	private void setDay(int daynum) {
		if ((daynum > 0)
				&& (daynum <= this.DaysInMonth(this.calDate.get(Calendar.YEAR),
						this.calDate.get(Calendar.MONTH) + 1))) {
			this.calDate.set(Calendar.DAY_OF_MONTH, daynum);
			this.update();
		}
	}

	private void update() {
		GregorianCalendar cal = new GregorianCalendar(this.calDate
				.get(Calendar.YEAR), this.calDate.get(Calendar.MONTH), 1);
		int currentDay = this.calDate.get(Calendar.DAY_OF_MONTH);
		int firstDayOfMonth = cal.get(Calendar.DAY_OF_WEEK);
		switch (firstDayOfMonth) {
		case Calendar.MONDAY:
			firstDayOfMonth = 0;
			break;
		case Calendar.TUESDAY:
			firstDayOfMonth = 1;
			break;
		case Calendar.WEDNESDAY:
			firstDayOfMonth = 2;
			break;
		case Calendar.THURSDAY:
			firstDayOfMonth = 3;
			break;
		case Calendar.FRIDAY:
			firstDayOfMonth = 4;
			break;
		case Calendar.SATURDAY:
			firstDayOfMonth = 5;
			break;
		case Calendar.SUNDAY:
			firstDayOfMonth = 6;
			break;
		default:
			break;
		}
		int daysInMonth = this.DaysInMonth(cal.get(Calendar.YEAR), cal
				.get(Calendar.MONTH) + 1);
		int dcount = 0;
		this.calMonthLabel.setText(cal.getDisplayName(Calendar.MONTH,
				Calendar.LONG, Locale.getDefault())
				+ " " + String.valueOf(cal.get(Calendar.YEAR))); //$NON-NLS-1$
		for (int[] l : this.calLabelList) {
			if (l != null) {
				this.calDay[l[0]][l[1]].setText(""); //$NON-NLS-1$
				this.calLabelMap[l[0]][l[1]] = -1;
			}
		}
		this.calLabelList = new LinkedList<int[]>();
		for (int y = 0; y < 6; y++)
			for (int x = 0; x < 7; x++)
				if (y == 0) {
					if (x >= firstDayOfMonth) {
						dcount++;
						this.calDay[y][x].setText(String.valueOf(dcount));
						this.calLabelMap[y][x] = dcount;
						int[] coord = { y, x };
						this.calLabelList.add(coord);
					}
					if (dcount != currentDay) {
						if ((dcount > 0) && this.calMarkedArray[dcount - 1]) {
							this.calDay[y][x].setOpaque(true);
							this.calDay[y][x].setBackground(Color.GREEN);
						} else
							this.calDay[y][x].setOpaque(false);
					} else
						if (((this.calLastDayChoosen[0] != y) || (this.calLastDayChoosen[1] != x))) {
							if (((this.calLastDayChoosen[0] != -1) && (this.calLastDayChoosen[1] != -1)))
								this.calDay[this.calLastDayChoosen[0]][this.calLastDayChoosen[1]]
										.setOpaque(false);
							this.calLastDayChoosen[0] = y;
							this.calLastDayChoosen[1] = x;
							this.calDay[y][x].setOpaque(true);
							this.calDay[y][x].setBackground(Color.RED);
						}
				} else {
					if ((dcount < daysInMonth) && (dcount > -1)) {
						dcount++;
						this.calDay[y][x].setText(String.valueOf(dcount));
						this.calLabelMap[y][x] = dcount;
						int[] coord = { y, x };
						this.calLabelList.add(coord);
					} else
						dcount = -1;
					if ((dcount > 0) && (dcount > -1) && (dcount == currentDay)) {
						if ((this.calLastDayChoosen[0] != y)
								|| (this.calLastDayChoosen[1] != x)) {
							if (((this.calLastDayChoosen[0] != -1) && (this.calLastDayChoosen[1] != -1)))
								if (!this.calDay[this.calLastDayChoosen[0]][this.calLastDayChoosen[1]]
										.getText().equals("") //$NON-NLS-1$
										&& this.calMarkedArray[Integer
												.parseInt(this.calDay[this.calLastDayChoosen[0]][this.calLastDayChoosen[1]]
														.getText()) - 1])
									this.calDay[this.calLastDayChoosen[0]][this.calLastDayChoosen[1]]
											.setBackground(Color.GREEN);
								else
									this.calDay[this.calLastDayChoosen[0]][this.calLastDayChoosen[1]]
											.setOpaque(false);
							this.calLastDayChoosen[0] = y;
							this.calLastDayChoosen[1] = x;
							this.calDay[y][x].setOpaque(true);
							this.calDay[y][x].setBackground(Color.RED);
						}
					} else
						if ((dcount > 0) && (dcount > -1)
								&& this.calMarkedArray[dcount - 1]) {
							this.calDay[y][x].setOpaque(true);
							this.calDay[y][x].setBackground(Color.GREEN);
						} else
							this.calDay[y][x].setOpaque(false);
				}
	}
}
