import java.awt.Point;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.Date;
import java.util.LinkedList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.AbstractListModel;

public class SearchResultWindow extends javax.swing.JFrame {

	private static final long serialVersionUID = -4386390071965187008L;

	private javax.swing.JList entryList;

	private javax.swing.JTextArea entryText;

	private javax.swing.JScrollPane jScrollPane1;

	private javax.swing.JScrollPane jScrollPane2;

	private javax.swing.JButton loadButton;

	private javax.swing.JButton searchButton;

	// public static void main(String args[]) {
	// java.awt.EventQueue.invokeLater(new Runnable() {
	// public void run() {
	// new SearchResultWindow().setVisible(true);
	// }
	// });
	// }

	private javax.swing.JTextField searchText;
	private MainWindowUI mainWindow;

	public SearchResultWindow(MainWindowUI mw, Point pos) {
		this.mainWindow = mw;
		this.initComponents(pos);
	}

	private void initComponents(Point pos) {
		this.setLocation(pos);
		this.setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		this.setTitle(Messages.getString("SearchResultWindow.search")); //$NON-NLS-1$
		this.setName("Tagebuch Suchfenster"); //$NON-NLS-1$
		this.jScrollPane2 = new javax.swing.JScrollPane();
		this.entryText = new javax.swing.JTextArea();
		this.loadButton = new javax.swing.JButton();
		this.jScrollPane1 = new javax.swing.JScrollPane();
		this.entryList = new javax.swing.JList();
		this.searchText = new javax.swing.JTextField();
		this.searchButton = new javax.swing.JButton();
		this.entryText.setColumns(20);
		this.entryText.setLineWrap(true);
		this.entryText.setRows(5);
		this.entryText.setWrapStyleWord(true);
		this.jScrollPane2.setViewportView(this.entryText);

		this.loadButton.setText(Messages.getString("MainWindowUI.Load")); //$NON-NLS-1$
		this.loadButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SearchResultWindow.this.loadButtonMouseClicked(evt);
			}
		});

		entryList
				.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
					@Override
					public void valueChanged(
							javax.swing.event.ListSelectionEvent evt) {
						entryListValueChanged(evt);
					}
				});
		this.jScrollPane1.setViewportView(this.entryList);

		this.searchButton.setText(Messages
				.getString("SearchResultWindow.search")); //$NON-NLS-1$
		this.searchButton.addMouseListener(new java.awt.event.MouseAdapter() {
			@Override
			public void mouseClicked(java.awt.event.MouseEvent evt) {
				SearchResultWindow.this.searchButtonMouseClicked(evt);
			}
		});

		javax.swing.GroupLayout layout = new javax.swing.GroupLayout(
				this.getContentPane());
		this.getContentPane().setLayout(layout);
		layout.setHorizontalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addComponent(this.loadButton,
						javax.swing.GroupLayout.DEFAULT_SIZE, 450,
						Short.MAX_VALUE)
				.addGroup(
						layout.createSequentialGroup()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING,
												false)
												.addComponent(
														this.searchButton,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														Short.MAX_VALUE)
												.addComponent(
														this.jScrollPane1,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														150, Short.MAX_VALUE))
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.LEADING)
												.addComponent(
														this.searchText,
														javax.swing.GroupLayout.Alignment.TRAILING,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														300, Short.MAX_VALUE)
												.addComponent(
														this.jScrollPane2,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														300, Short.MAX_VALUE))));
		layout.setVerticalGroup(layout
				.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
				.addGroup(
						layout.createSequentialGroup()
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.BASELINE)
												.addComponent(
														this.searchText,
														javax.swing.GroupLayout.PREFERRED_SIZE,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														javax.swing.GroupLayout.PREFERRED_SIZE)
												.addComponent(this.searchButton))
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addGroup(
										layout.createParallelGroup(
												javax.swing.GroupLayout.Alignment.TRAILING,
												false)
												.addComponent(this.jScrollPane2)
												.addComponent(
														this.jScrollPane1,
														javax.swing.GroupLayout.DEFAULT_SIZE,
														300, Short.MAX_VALUE))
								.addPreferredGap(
										javax.swing.LayoutStyle.ComponentPlacement.RELATED)
								.addComponent(this.loadButton)));

		this.pack();
	}

	@SuppressWarnings("deprecation")
	private void loadButtonMouseClicked(java.awt.event.MouseEvent evt) {
		Object value = this.entryList.getSelectedValue();
		if (value == null)
			return;
		String seperator = File.separator;
		if (seperator.equals("\\")) //$NON-NLS-1$
			seperator = "\\\\"; //$NON-NLS-1$
		Matcher m = Pattern
				.compile(
						".*"	+ seperator + "(\\d{4})" + seperator + "(\\d{2})" + seperator + "(\\d{2})\\.tb").matcher( //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
						(String) value);
		if (m.find()) {
			this.mainWindow.getTBCal().setDate(
					new Date(Integer.parseInt(m.group(1)) - 1900, Integer
							.parseInt(m.group(2)) - 1, Integer.parseInt(m
							.group(3))));
			this.mainWindow.TBLoadButtonMouseClicked();
		}
		this.dispose();
	}

	private String removeFileHeader(String fileContend) {
		String oldHeader = "<SPEEDPROGLUATB>"; //$NON-NLS-1$
		String oldFooter = "</SPEEDPROGLUATB>"; //$NON-NLS-1$
		String newHeader = "<SPDIARY +version=\"(\\d)\" +datum=\"(\\d\\d\\d\\d\\.\\d\\d\\.\\d\\d)\" *(.*)>"; //$NON-NLS-1$
		String newFooter = "</SPDIARY>"; //$NON-NLS-1$
		Pattern oldTags = Pattern
				.compile("(?s)" + oldHeader + "(.*)" + oldFooter); //$NON-NLS-1$ //$NON-NLS-2$
		Pattern newTags = Pattern
				.compile("(?s)" + newHeader + "(.*)" + newFooter); //$NON-NLS-1$ //$NON-NLS-2$
		String retC;
		Matcher tm = oldTags.matcher(fileContend);
		if (tm.find())
			retC = tm.group(1);
		else {
			tm = newTags.matcher(fileContend);
			if (tm.find())
				retC = tm.group(4);
			else
				retC = fileContend;
		}
		return retC;
	}

	private void searchButtonMouseClicked(java.awt.event.MouseEvent evt) {
		this.entryText.setText(Messages
				.getString("SearchResultWindow.pleaseWaitSearching")); //$NON-NLS-1$
		AbstractListModel entryListModel = new AbstractListModel() {
			private static final long serialVersionUID = 7540505109367703542L;

			LinkedList<File> list = TBSearch
					.getSearchResults(SearchResultWindow.this.searchText
							.getText());

			@Override
			public Object getElementAt(int i) {
				return this.list.get(i).getPath();
			}

			@Override
			public int getSize() {
				if (this.list == null)
					this.list = new LinkedList<File>();
				return this.list.size();
			}
		};
		this.entryText.setText(Messages
				.getString("SearchResultWindow.searchFinished") //$NON-NLS-1$
				+ entryListModel.getSize());
		this.entryList.setModel(entryListModel);
	}

	private void entryListValueChanged(javax.swing.event.ListSelectionEvent evt) {
		String fileContend;
		Object value = this.entryList.getSelectedValue();
		if (value == null)
			return;
		File f = new File((String) value);
		if (!f.exists())
			fileContend = ""; //$NON-NLS-1$
		else {
			BufferedReader br = null;
			try {
				br = new BufferedReader(new InputStreamReader(
						new FileInputStream(f.getPath()), "UTF-8")); //$NON-NLS-1$
			} catch (FileNotFoundException e1) {
				e1.printStackTrace();
				return;
			} catch (UnsupportedEncodingException e) {
				e.printStackTrace();
				return;
			}
			StringBuffer contentOfFile = new StringBuffer();
			String line;
			try {
				while ((line = br.readLine()) != null)
					contentOfFile.append(line);
			} catch (IOException e) {
				e.printStackTrace();
			}
			try {
				br.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			fileContend = contentOfFile.toString();
		}
		this.entryText.setText(this.removeFileHeader(fileContend));
	}
}
