import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.util.LinkedList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class TBSearch {
	public final static LinkedList<File> getSearchResults(String text) {
		LinkedList<File> entryList = new LinkedList<File>();
		//		SimpleDateFormat df = new SimpleDateFormat(".\\yyyy\\"); //$NON-NLS-1$
		// df.setTimeZone(TimeZone.getDefault());
		// String path = df.format(year);
		File f = new File("." + File.separator); //$NON-NLS-1$
		if (f.exists() && f.isDirectory()) {
			File[] years = f.listFiles(new YearfolderFilter());
			for (File y : years) {
				File[] months = y.listFiles();
				for (File m : months) {
					if (m.exists() && m.isDirectory()) {
						File[] files = m.listFiles(new TBFileFilter());
						for (File fi : files) {
							String fileContend;
							if (!fi.exists())
								fileContend = ""; //$NON-NLS-1$
							else {
								BufferedReader br = null;
								try {
									br = new BufferedReader(
											new InputStreamReader(
													new FileInputStream(fi
															.getPath()),
													"UTF-8")); //$NON-NLS-1$
								} catch (FileNotFoundException e1) {
									e1.printStackTrace();
									return null;
								} catch (UnsupportedEncodingException e) {
									e.printStackTrace();
									return null;
								}
								StringBuffer contentOfFile = new StringBuffer();
								String line;
								try {
									while ((line = br.readLine()) != null)
										contentOfFile.append(line);
								} catch (IOException e) {
									e.printStackTrace();
								}
								try {
									br.close();
								} catch (IOException e) {
									e.printStackTrace();
								}
								fileContend = contentOfFile.toString();
							}
							if (removeFileHeader(fileContend).indexOf(text) > -1)
								entryList.add(fi);
						}
					}
				}
			}
		}
		if (entryList.isEmpty())
			return null;
		return entryList;
	}

	private static String removeFileHeader(String fileContend) {
		String oldHeader = "<SPEEDPROGLUATB>"; //$NON-NLS-1$
		String oldFooter = "</SPEEDPROGLUATB>"; //$NON-NLS-1$
		String newHeader = "<SPDIARY +version=\"(\\d)\" +datum=\"(\\d\\d\\d\\d\\.\\d\\d\\.\\d\\d)\" *(.*)>"; //$NON-NLS-1$
		String newFooter = "</SPDIARY>"; //$NON-NLS-1$
		Pattern oldTags = Pattern
				.compile("(?s)" + oldHeader + "(.*)" + oldFooter); //$NON-NLS-1$ //$NON-NLS-2$
		Pattern newTags = Pattern
				.compile("(?s)" + newHeader + "(.*)" + newFooter); //$NON-NLS-1$ //$NON-NLS-2$
		String retC;
		Matcher tm = oldTags.matcher(fileContend);
		if (tm.find())
			retC = tm.group(1);
		else {
			tm = newTags.matcher(fileContend);
			if (tm.find())
				retC = tm.group(4);
			else
				retC = fileContend;
		}
		return retC;
	}
}
